#include "s0039_combination_sum.hpp"

#include <gtest/gtest.h>

TEST(Problem39, Case1) {
  vector<int> candidates{2, 3, 6, 7};
  int target{7};
  vector<vector<int>> o{{7}, {2, 2, 3}};
  S0039 solution;
  EXPECT_EQ(solution.combinationSum(candidates, target), o);
}

TEST(Problem39, Case2) {
  vector<int> candidates{2, 3, 5};
  int target{8};
  vector<vector<int>> o{{3, 5}, {2, 3, 3}, {2, 2, 2, 2}};
  S0039 solution;
  EXPECT_EQ(solution.combinationSum(candidates, target), o);
}

TEST(Problem39, Case3) {
  vector<int> candidates{2};
  int target{1};
  vector<vector<int>> o{};
  S0039 solution;
  EXPECT_EQ(solution.combinationSum(candidates, target), o);
}
